package cn.skcks.docking.gb28181.wvp.api.video.dto;

import cn.hutool.core.date.DatePattern;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.v3.oas.annotations.media.Schema;
import jakarta.validation.constraints.NotBlank;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@NoArgsConstructor
@Data
public class VideoReq {

    @NotBlank(message = "设备编码 不能为空")
    @Schema(description = "设备编码 (支持参数名: deviceCode device_code deviceId device_id)")
    private String deviceCode;

    @Schema(description = "开始时间 (支持参数名: startTime start_time beginTime begin_time)",example = "20230909000000")
    @NotBlank(message = "开始时间 不能为空")
    @DateTimeFormat(pattern= DatePattern.PURE_DATETIME_PATTERN)
    @JsonFormat(pattern = DatePattern.PURE_DATETIME_PATTERN)
    private Date startTime;

    @Schema(description = "结束时间 (支持参数名: endTime end_time endTime end_time)",example = "20230909000500")
    @NotBlank(message = "结束时间 不能为空")
    @DateTimeFormat(pattern= DatePattern.PURE_DATETIME_PATTERN)
    @JsonFormat(pattern = DatePattern.PURE_DATETIME_PATTERN)
    private Date endTime;

    public void setDevice_id(String deviceCode){
        this.deviceCode = deviceCode;
    }

    public void setDevice_code(String deviceCode){
        this.deviceCode = deviceCode;
    }

    @DateTimeFormat(pattern= DatePattern.PURE_DATETIME_PATTERN)
    @JsonFormat(pattern = DatePattern.PURE_DATETIME_PATTERN)
    public void setBegin_time(Date startTime){
        this.startTime = startTime;
    }

    @DateTimeFormat(pattern= DatePattern.PURE_DATETIME_PATTERN)
    @JsonFormat(pattern = DatePattern.PURE_DATETIME_PATTERN)
    public void setStart_time(Date startTime){
        this.startTime = startTime;
    }

    @DateTimeFormat(pattern= DatePattern.PURE_DATETIME_PATTERN)
    @JsonFormat(pattern = DatePattern.PURE_DATETIME_PATTERN)
    public void setEnd_time(Date endTime){
        this.endTime = endTime;
    }
}
